<div ng-controller="advancementListController as self" ng-init="self.init('<?= $this->from ?>', <?= $this->object ? $this->object->getId() : 'null' ?>)">
    <div class="row" ng-show="self.view == 'timeline'">
        <div class="col-xs-12">
            <div class="row separator">
                <div class="col-sm-offset-8 col-sm-4">
                    <div class="btn-group pull-right">
                        <button class="btn btn-lg btn-excel" type="button" ng-click="__tb.exportExcel()"  tooltip="<?= $this->translate('tooltip_export_xls') ?>">
                            <?= $this->icon('excel', 'fa-fw pointer') ?>
                        </button>
                    </div>
                    <div class="btn-group pull-right">
                        <?php if ($this->acl()->isAllowed('advancement:e:advancement:c')) : ?>
                            <button type="button" class="btn btn-lg" ng-click="self.createAdvancement()" <?= ($this->from === 'project' && $this->acl()->onlyOwned('project:e:project:u') ? 'ng-if="self.isManager(' . $this->authStorage()->getUser()->getId() . ')"' : '') ?>>
                                <?= $this->icon('create') ?>
                                <?= $this->translate('advancement_nav_form'); ?>
                            </button>
                        <?php endif; ?>
                        <button class="btn btn-lg" ng-show="self.view == 'table'" ng-click="self.view = 'timeline'" tooltip="<?= $this->translate('tooltip_switch_view_advancement_timeline') ?>">
                            <?= $this->icon('timeline', 'fa-fw'); ?>
                        </button>
                        <button class="btn btn-lg" ng-show="self.view == 'timeline'" ng-click="self.view = 'table'" tooltip="<?= $this->translate('tooltip_switch_view_advancement_list') ?>">
                            <?= $this->icon('list', 'fa-fw'); ?>
                        </button>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-xs-12">
                    <div class="advancement-timeline-container">
                        <div class="text-up"><?= $this->translate('advancement_type_target') ?></div>
                        <div class="text-down"><?= $this->translate('advancement_type_done') ?></div>
                        <div class="advancement-timeline-jalons">
                            <div ng-repeat="advancement in self.advancements" class="timeline-jalon timeline-jalon-{{advancement.type}}" ng-style="{left: advancement.value + '%'}" id="{{advancement.id}}">
                                <div class="timeline-bar"></div>
                                <div class="timeline-panel">
                                    <?php if ($this->acl()->isAllowed('advancement:e:advancement:d')) : ?>
                                    <div ng-if="advancement._rights.delete" ng-click="self.deleteAdvancement(advancement);" class="remove" tooltip="<?= $this->translate('tooltip_delete') ?>">
                                        <?= $this->icon('delete') ?>
                                    </div>
                                    <?php endif; ?>
                                    <div class="value">
                                        {{advancement.value}}%
                                    </div>
                                    <div class="date">
                                        {{advancement.date | dateFormat : 'DD/MM/YYYY'}}
                                    </div>
                                    <div class="name" ng-class="{
                                        'to-left': advancement.value > 50,
                                        'to-right': advancement.value <= 50
                                    }">
                                        {{advancement.name}}
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="progress advancement-progress-project-tab">
                            <?php if ($this->acl()->isAllowed('advancement:e:advancement:c')) : ?>
                            <div class="timeline-create" ng-click="self.createAdvancementFromTimeline()" data-toggle="tooltip" data-placement="top" title="Tooltip on top" <?= ($this->from === 'project' && $this->acl()->onlyOwned('project:e:project:u') ? 'ng-show="self.isManager(' . $this->authStorage()->getUser()->getId() . ')"' : '') ?>>
                                <i class="fa fa-plus-circle"></i>
                            </div>
                            <?php endif; ?>
                            <div class="progress-bar progress-done" ng-style="{width: self.stackedBar.done + '%'}" title="{{self.stackedBar.done}}%">
                                <?= $this->translate('advancement_type_done') ?> - {{self.stackedBar.done}}%
                            </div>
                            <div class="progress-bar progress-late" ng-style="{width: self.stackedBar.late + '%'}" title="{{self.stackedBar.late}}%">
                                Retard - {{self.stackedBar.late}}%
                            </div>
                            <div class="progress-bar progress-upper-target" ng-style="{width: self.stackedBar.upperTarget + '%'}" title="{{self.stackedBar.upperTarget}}%">
                                Restant - {{self.stackedBar.upperTarget}}%
                            </div>
                            <div class="progress-bar progress-target" ng-style="{width: self.stackedBar.totalTarget + '%'}" title="{{self.stackedBar.totalTarget}}%">
                                <?= $this->translate('advancement_type_target') ?> - {{self.stackedBar.totalTarget}}%
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="row" ng-show="self.view == 'table'">
        <div class="col-xs-12">
            <table-builder options="self.options" items="self.advancements" class="table-builder">
                <div class="row separator">
                    <div class="col-xs-12">
                        <div class="progress advancement-progress-project-tab">
                            <div class="progress-bar progress-done" ng-style="{width: self.stackedBar.done + '%'}" title="{{self.stackedBar.done}}%">
                                <?= $this->translate('advancement_type_done') ?> - {{self.stackedBar.done}}%
                            </div>
                            <div class="progress-bar progress-late" ng-style="{width: self.stackedBar.late + '%'}" title="{{self.stackedBar.late}}%">
                                Retard - {{self.stackedBar.late}}%
                            </div>
                            <div class="progress-bar progress-upper-target" ng-style="{width: self.stackedBar.upperTarget + '%'}" title="{{self.stackedBar.upperTarget}}%">
                                Restant - {{self.stackedBar.upperTarget}}%
                            </div>
                            <div class="progress-bar progress-target" ng-style="{width: self.stackedBar.totalTarget + '%'}" title="{{self.stackedBar.totalTarget}}%">
                                <?= $this->translate('advancement_type_target') ?> - {{self.stackedBar.totalTarget}}%
                            </div>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-sm-4">
                        <div class="table-filters little-panel">
                            <div class="title" data-toggle="collapse" href="#filters-collapsed-advancement">
                                <?= $this->icon('filters', 'fa-fw') ?>
                                <?= $this->translate('filters') ?>
                            </div>
                            <div id="filters-collapsed-advancement" class="body collapse">
                                <?php
                                $filters = [
                                    'date' => [
                                        'label' => $this->translate('advancement_field_date'),
                                        'type'  => 'date'
                                    ],
                                    'name' => [
                                        'label' => $this->translate('advancement_field_name'),
                                        'type'  => 'string'
                                    ],
                                    'description' => [
                                        'label' => $this->translate('advancement_field_description'),
                                        'type'  => 'string'
                                    ],
                                    'value' => [
                                        'label' => $this->translate('advancement_field_value'),
                                        'type'  => 'number'
                                    ],
                                    'createdAt' => [
                                        'label' => $this->translate('advancement_field_createdAt'),
                                        'type'  => 'date'
                                    ],
                                    'updatedAt' => [
                                        'label' => $this->translate('advancement_field_updatedAt'),
                                        'type'  => 'date'
                                    ],
                                ];

                                echo $this->tableFilter('__tb.apiParams.search.data.filters', $filters);
                                ?>
                                <div class="row">
                                    <div class="col-xs-6">
                                        <button class="btn" ng-click="self.resetfullTextSearch(); __tb.resetFilters(); __tb.loadData()"><?= $this->translate('table_filter_reset_button') ?></button>
                                    </div>
                                    <div class="col-xs-6 text-right">
                                        <button class="btn" ng-click="self.resetfullTextSearch(); __tb.loadData()">
                                            <?= $this->icon('search', 'fa-fw') ?>
                                            <?= $this->translate('table_filter_button') ?>
                                        </button>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="col-sm-4">
                        <table-builder-columns></table-builder-columns>
                    </div>
                    <div class="col-sm-4">
                        <div class="btn-group pull-right">
                            <button class="btn btn-lg" ng-click="__tb.removeFromList()" tooltip="<?= $this->translate('tooltip_remove_from_list') ?>">
                                <?= $this->icon('eraser', 'fa-fw pointer') ?>
                            </button>
                            <button class="btn btn-lg btn-excel" type="button" ng-click="__tb.exportExcel()" tooltip="<?= $this->translate('tooltip_export_xls') ?>">
                                <?= $this->icon('excel', 'fa-fw pointer') ?>
                            </button>
                        </div>
                        <div class="btn-group pull-right">
                            <?php if ($this->acl()->isAllowed('advancement:e:advancement:c')) : ?>
                                <button type="button" class="btn btn-lg" ng-click="self.createAdvancement()" <?= ($this->from === 'project' && $this->acl()->onlyOwned('project:e:project:u') ? 'ng-if="self.isManager(' . $this->authStorage()->getUser()->getId() . ')"' : '') ?>>
                                    <?= $this->icon('create') ?>
                                    <?= $this->translate('advancement_nav_form'); ?>
                                </button>
                            <?php endif; ?>
                            <button class="btn btn-lg" ng-show="self.view == 'table'" ng-click="self.view = 'timeline'" tooltip="<?= $this->translate('tooltip_switch_view_advancement_timeline') ?>">
                                <?= $this->icon('timeline', 'fa-fw'); ?>
                            </button>
                            <button class="btn btn-lg" ng-show="self.view == 'timeline'" ng-click="self.view = 'table'" tooltip="<?= $this->translate('tooltip_switch_view_advancement_list') ?>">
                                <?= $this->icon('list', 'fa-fw'); ?>
                            </button>
                        </div>
                    </div>
                </div>
                <div class="row">
                    <div class="col-xs-12">
                        <form name="advancementForm">
                            <table table-builder-table class="table table-bordered table-condensed table-hover">
                                <thead>
                                <tr>
                                    <th tb-column tb-name="selection" class="checkbox-column"><input type="checkbox" ng-model="__tb.selection"/></th>
                                    <th tb-column tb-name="date"  tb-sortable="true" tb-toggle="true"><?= $this->translate('advancement_field_date') ?></th>
                                    <th tb-column tb-name="name"  tb-sortable="true" tb-toggle="true"><?= $this->translate('advancement_field_name') ?></th>
                                    <th tb-column tb-name="value"  tb-sortable="true" tb-toggle="true"><?= $this->translate('advancement_field_value') ?></th>
                                    <th tb-column tb-name="description"  tb-sortable="true" tb-toggle="true" tb-hidden="true"><?= $this->translate('advancement_field_description') ?></th>
                                    <th tb-column tb-name="type"      tb-sortable="true" tb-toggle="true" tb-hidden="true"><?= $this->translate('advancement_field_type') ?></th>
                                    <th tb-column tb-name="createdAt"  tb-sortable="true" tb-toggle="true" tb-hidden="true"><?= $this->translate('advancement_field_createdAt') ?></th>
                                    <th tb-column tb-name="updatedAt"  tb-sortable="true" tb-toggle="true" tb-hidden="true"><?= $this->translate('advancement_field_updatedAt') ?></th>
                                    <th tb-column tb-name="actions" class="actions-column"></th>
                                </tr>
                                </thead>
                                <tbody></tbody>
                                <tbody ng-repeat="(type, advancements) in self.advancements | groupBy : 'type'">
                                <tr class="group">
                                    <td colspan="6" class="pointer" ng-click="self.showAdvancements = !self.showAdvancements">
                                        <i class="fa" ng-class="{'fa-caret-right' : !self.showAdvancements, 'fa-caret-down' : self.showAdvancements}"></i>
                                        {{'advancement_type_' + advancements[0].type | translate}}
                                    </td>
                                </tr>
                                <tr ng-repeat="advancement in advancements" ng-class="{editing: self.editedLine == advancement}" ng-show="self.showAdvancements">
                                    <td><input type="checkbox" ng-model="advancement.selected" /></td>
                                    <td class="editable">
                                        <span ng-show="self.editedLine !== advancement">
                                            {{advancement.date | dateFormat : 'DD/MM/YYYY'}}
                                            <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(advancement)', 'ng-if' => 'advancement._rights.update']) ?>
                                        </span>
                                        <span ng-show="self.editedLine == advancement">
                                            <input type="text" name="date" class="form-control input-sm" required autocomplete="off"
                                                   input-mask="qdate"
                                                   ng-model="self.editedLineFields.date" />
                                            <field-errors field="date" errors="self.editedLineErrors"></field-errors>
                                        </span>
                                    </td>
                                    <td class="editable">
                                        <span ng-show="self.editedLine !== advancement">
                                            {{advancement.name}}
                                            <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(advancement)', 'ng-if' => 'advancement._rights.update']) ?>
                                        </span>
                                        <span ng-show="self.editedLine == advancement">
                                            <input type="text" name="name" class="form-control input-sm" autocomplete="off"
                                                   ng-model="self.editedLineFields.name" />
                                            <field-errors field="name" errors="self.editedLineErrors"></field-errors>
                                        </span>
                                    </td>
                                    <td class="editable text-right">
                                        <span ng-show="self.editedLine !== advancement">
                                            <div class="progress">
                                                <div class="progress-bar" role="progressbar" aria-valuenow="{{advancement.value}}" aria-valuemin="0" aria-valuemax="100" ng-style="{width: advancement.value + '%'}">
                                                    {{advancement.value}} %
                                                </div>
                                            </div>
                                            <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(advancement)', 'ng-if' => 'advancement._rights.update']) ?>
                                        </span>
                                        <span ng-show="self.editedLine == advancement">
                                            <input type="text" input-mask="decimal" required class="form-control input-sm"
                                                   ng-model="self.editedLineFields.value"/>
                                            <field-errors field="value" errors="self.editedLineErrors"></field-errors>
                                        </span>
                                    </td>
                                    <td>
                                        <span ng-show="self.editedLine !== advancement">
                                            {{ advancement.description }}
                                        </span>
                                    </td>
                                    <td class="editable">
                                        <span ng-show="self.editedLine !== advancement">
                                            {{'advancement_type_' + advancement.type | translate}}
                                            <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(advancement)', 'ng-if' => 'advancement._rights.update']) ?>
                                        </span>
                                        <span ng-show="self.editedLine == advancement">
                                            <select class="form-control" required
                                                    ng-model="self.editedLineFields.type">
                                                <?php
                                                foreach (\Advancement\Entity\Advancement::getTypes() as $type) {
                                                    echo '<option value="' . $type . '">' . $this->translate('advancement_type_' . $type) . '</option>';
                                                }
                                                ?>
                                            </select>
                                            <field-errors field="type" errors="self.editedLineErrors"></field-errors>
                                        </span>

                                    </td>
                                    <td>{{advancement.createdAt | dateFormat : 'DD/MM/YYYY'}}</td>
                                    <td>{{advancement.updatedAt | dateFormat : 'DD/MM/YYYY'}}</td>
                                    <td>
                                        <div class="btn-group btn-group-actions" ng-if="self.editedLine != advancement">
                                            <?php if ($this->acl()->isAllowed('advancement:e:advancement:r')) : ?>
                                                <a ng-if="advancement._rights.read" class="btn btn-xs btn-default" ng-click="self.editAdvancement(advancement);" tooltip="<?= $this->translate('tooltip_edit') ?>">
                                                    <?= $this->icon('edit') ?>
                                                </a>
                                            <?php endif; ?>

                                            <?php if ($this->acl()->isAllowed('advancement:e:advancement:d')) : ?>
                                                <a ng-if="advancement._rights.delete" ng-click="self.deleteAdvancement(advancement);" class="btn btn-xs btn-default" tooltip="<?= $this->translate('tooltip_delete') ?>">
                                                    <?= $this->icon('delete') ?>
                                                </a>
                                            <?php endif; ?>
                                        </div>
                                        <div class="btn-group btn-group-actions" ng-if="self.editedLine == advancement">
                                            <button class="btn btn-xs btn-default" ng-click="self.saveEditedLine(advancement)" type="submit" tooltip="<?= $this->translate('tooltip_save') ?>">
                                                <?= $this->icon('save') ?>
                                            </button>
                                            <button class="btn btn-xs btn-default" ng-click="self.editedLine = null" type="button" tooltip="<?= $this->translate('tooltip_cancel') ?>">
                                                <?= $this->icon('close') ?>
                                            </button>
                                        </div>
                                    </td>
                                </tr>
                                </tbody>
                            </table>
                        </form>
                    </div>
                </div>
            </table-builder>
        </div>
    </div>

    <?= $this->partial('advancement/partial/form.phtml', ['from' => $this->from, 'object' => $this->object]) ?>
</div>
